package com.jasamedika.medifirst2000.controller;

import java.io.IOException;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.client.HttpClientErrorException;

import com.jasamedika.medifirst2000.constants.Constants;
import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.core.web.WebConstants;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.IndikatorBIOSTransaksiService;
import com.jasamedika.medifirst2000.util.rest.RestUtil;
import com.jasamedika.medifirst2000.vo.LoginUserVO;

@RestController
@RequestMapping("/integrasi")
public class IntegrationController extends LocaleController<LoginUserVO> {

	private static final Logger LOGGER = LoggerFactory.getLogger(IntegrationController.class);

	@Autowired
	IndikatorBIOSTransaksiService indikatorBIOSTransaksiService;

	@RequestMapping(value = "/send-to-bios", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<List<Map<String, Object>>> getListRincianKegiatan(HttpServletRequest request,
			@RequestParam(value = "bulan", required = true) String bulan,
			@RequestParam(value = "noRec", required = false) String noRec,
			@RequestParam(value = "jenisIndikator", required = false, defaultValue = "0") Integer jenisIndikator)
			throws IOException {
		try {
			List<Map<String, Object>> result = indikatorBIOSTransaksiService.sendToBIOSG2(bulan, noRec, jenisIndikator);
			mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,
					getMessage(MessageResource.LABEL_SUCCESS, request));
			return RestUtil.getJsonResponse(result, HttpStatus.OK, mapHeaderMessage);
		} catch (HttpClientErrorException he) {
			LOGGER.error("Got exception {} when get response send to bios", he.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, he.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.TOO_MANY_REQUESTS, mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when get response send to bios", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when get response send to bios", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT, mapHeaderMessage);
		}
	}

	@RequestMapping(value = "/get-list-bank", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> getListBank(HttpServletRequest request) {
		try {
			Map<String, Object> result = indikatorBIOSTransaksiService.getResponseDataBankBIOS();
			mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,
					getMessage(MessageResource.LABEL_SUCCESS, request));
			return RestUtil.getJsonResponse(result, HttpStatus.OK, mapHeaderMessage);
		} catch (HttpClientErrorException he) {
			LOGGER.error("Got exception {} when get list bank", he.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, he.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.TOO_MANY_REQUESTS, mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when get list bank", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when get list bank", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT, mapHeaderMessage);
		}
	}

	@RequestMapping(value = "/get-list-rekening", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> getListRekening(HttpServletRequest request) {
		try {
			Map<String, Object> result = indikatorBIOSTransaksiService.getResponseDataRekeningBIOS();
			mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,
					getMessage(MessageResource.LABEL_SUCCESS, request));
			return RestUtil.getJsonResponse(result, HttpStatus.OK, mapHeaderMessage);
		} catch (HttpClientErrorException he) {
			LOGGER.error("Got exception {} when get list rekening", he.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, he.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.TOO_MANY_REQUESTS, mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when get list rekening", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when get list rekening", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT, mapHeaderMessage);
		}
	}

}
